/* engine.c generated by valac 0.56.17, the Vala compiler
 * generated from engine.vala, do not modify */

/*
 * Copyright (c) 2011 Lucas Baudin <xapantu@gmail.com>
 *
 * This is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; see the file COPYING.  If not,
 * write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 */

#include "word-completion.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	EUCLIDE_COMPLETION_PARSER_0_PROPERTY,
	EUCLIDE_COMPLETION_PARSER_NUM_PROPERTIES
};
static GParamSpec* euclide_completion_parser_properties[EUCLIDE_COMPLETION_PARSER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _EuclideCompletionParserPrivate {
	ScratchPluginsPrefixTree* prefix_tree;
	GRecMutex __lock_prefix_tree;
};

static gint EuclideCompletionParser_private_offset;
static gpointer euclide_completion_parser_parent_class = NULL;
static GType euclide_completion_parser_type_id = 0;

static gboolean _euclide_completion_parser_is_delimiter_gtk_text_char_predicate (gunichar ch,
                                                                          gpointer self);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
static gboolean euclide_completion_parser_parse_string (EuclideCompletionParser* self,
                                                 const gchar* text);
static void euclide_completion_parser_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
euclide_completion_parser_get_instance_private (EuclideCompletionParser* self)
{
	return G_STRUCT_MEMBER_P (self, EuclideCompletionParser_private_offset);
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1204 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1205 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1205 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1207 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1207 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 99 "engine.c"
		gchar* _tmp2_;
#line 1208 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1208 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1208 "glib-2.0.vapi"
		return result;
#line 107 "engine.c"
	} else {
#line 1210 "glib-2.0.vapi"
		result = -1;
#line 1210 "glib-2.0.vapi"
		return result;
#line 113 "engine.c"
	}
}

gboolean
euclide_completion_parser_is_delimiter (gunichar c)
{
	gboolean result;
#line 29 "../plugins/word-completion/engine.vala"
	result = string_index_of_char (EUCLIDE_COMPLETION_PARSER_DELIMITERS, c, 0) >= 0;
#line 29 "../plugins/word-completion/engine.vala"
	return result;
#line 125 "engine.c"
}

static gboolean
_euclide_completion_parser_is_delimiter_gtk_text_char_predicate (gunichar ch,
                                                                 gpointer self)
{
	gboolean result;
	result = euclide_completion_parser_is_delimiter (ch);
#line 33 "../plugins/word-completion/engine.vala"
	return result;
#line 136 "engine.c"
}

void
euclide_completion_parser_back_to_word_start (GtkTextIter* iter)
{
#line 32 "../plugins/word-completion/engine.vala"
	g_return_if_fail (iter != NULL);
#line 33 "../plugins/word-completion/engine.vala"
	gtk_text_iter_backward_find_char (iter, _euclide_completion_parser_is_delimiter_gtk_text_char_predicate, NULL, NULL);
#line 34 "../plugins/word-completion/engine.vala"
	gtk_text_iter_forward_char (iter);
#line 148 "engine.c"
}

EuclideCompletionParser*
euclide_completion_parser_construct (GType object_type)
{
	EuclideCompletionParser * self = NULL;
	GeeHashMap* _tmp0_;
	ScratchPluginsPrefixTree* _tmp1_;
#line 40 "../plugins/word-completion/engine.vala"
	self = (EuclideCompletionParser*) g_object_new (object_type, NULL);
#line 41 "../plugins/word-completion/engine.vala"
	_tmp0_ = gee_hash_map_new (gtk_text_view_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, SCRATCH_PLUGINS_TYPE_PREFIX_TREE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 41 "../plugins/word-completion/engine.vala"
	_g_object_unref0 (self->text_view_words);
#line 41 "../plugins/word-completion/engine.vala"
	self->text_view_words = _tmp0_;
#line 42 "../plugins/word-completion/engine.vala"
	_tmp1_ = scratch_plugins_prefix_tree_new ();
#line 42 "../plugins/word-completion/engine.vala"
	_g_object_unref0 (self->priv->prefix_tree);
#line 42 "../plugins/word-completion/engine.vala"
	self->priv->prefix_tree = _tmp1_;
#line 40 "../plugins/word-completion/engine.vala"
	return self;
#line 173 "engine.c"
}

EuclideCompletionParser*
euclide_completion_parser_new (void)
{
#line 40 "../plugins/word-completion/engine.vala"
	return euclide_completion_parser_construct (EUCLIDE_COMPLETION_TYPE_PARSER);
#line 181 "engine.c"
}

gboolean
euclide_completion_parser_match (EuclideCompletionParser* self,
                                 const gchar* to_find)
{
	ScratchPluginsPrefixTree* _tmp0_;
	gboolean result;
#line 45 "../plugins/word-completion/engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 45 "../plugins/word-completion/engine.vala"
	g_return_val_if_fail (to_find != NULL, FALSE);
#line 46 "../plugins/word-completion/engine.vala"
	_tmp0_ = self->priv->prefix_tree;
#line 46 "../plugins/word-completion/engine.vala"
	result = scratch_plugins_prefix_tree_find_prefix (_tmp0_, to_find);
#line 46 "../plugins/word-completion/engine.vala"
	return result;
#line 200 "engine.c"
}

static void
_g_free0_ (gpointer var)
{
#line 50 "../plugins/word-completion/engine.vala"
	var = (g_free (var), NULL);
#line 208 "engine.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 50 "../plugins/word-completion/engine.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 216 "engine.c"
}

gboolean
euclide_completion_parser_get_for_word (EuclideCompletionParser* self,
                                        const gchar* to_find,
                                        GList** list)
{
	GList* _vala_list = NULL;
	ScratchPluginsPrefixTree* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gboolean result;
#line 49 "../plugins/word-completion/engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 49 "../plugins/word-completion/engine.vala"
	g_return_val_if_fail (to_find != NULL, FALSE);
#line 50 "../plugins/word-completion/engine.vala"
	_tmp0_ = self->priv->prefix_tree;
#line 50 "../plugins/word-completion/engine.vala"
	_tmp1_ = scratch_plugins_prefix_tree_get_all_matches (_tmp0_, to_find);
#line 50 "../plugins/word-completion/engine.vala"
	(_vala_list == NULL) ? NULL : (_vala_list = (_g_list_free__g_free0_ (_vala_list), NULL));
#line 50 "../plugins/word-completion/engine.vala"
	_vala_list = _tmp1_;
#line 51 "../plugins/word-completion/engine.vala"
	_tmp2_ = g_list_first (_vala_list);
#line 51 "../plugins/word-completion/engine.vala"
	result = _tmp2_ != NULL;
#line 51 "../plugins/word-completion/engine.vala"
	if (list) {
#line 51 "../plugins/word-completion/engine.vala"
		*list = _vala_list;
#line 249 "engine.c"
	} else {
#line 51 "../plugins/word-completion/engine.vala"
		(_vala_list == NULL) ? NULL : (_vala_list = (_g_list_free__g_free0_ (_vala_list), NULL));
#line 253 "engine.c"
	}
#line 51 "../plugins/word-completion/engine.vala"
	return result;
#line 257 "engine.c"
}

void
euclide_completion_parser_rebuild_word_list (EuclideCompletionParser* self,
                                             GtkTextView* view)
{
	ScratchPluginsPrefixTree* _tmp0_;
#line 54 "../plugins/word-completion/engine.vala"
	g_return_if_fail (self != NULL);
#line 54 "../plugins/word-completion/engine.vala"
	g_return_if_fail (view != NULL);
#line 55 "../plugins/word-completion/engine.vala"
	_tmp0_ = self->priv->prefix_tree;
#line 55 "../plugins/word-completion/engine.vala"
	scratch_plugins_prefix_tree_clear (_tmp0_);
#line 56 "../plugins/word-completion/engine.vala"
	euclide_completion_parser_parse_text_view (self, view);
#line 275 "engine.c"
}

void
euclide_completion_parser_parse_text_view (EuclideCompletionParser* self,
                                           GtkTextView* view)
{
	GtkTextBuffer* _tmp6_;
	GtkTextBuffer* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gboolean _tmp13_;
	GError* _inner_error0_ = NULL;
#line 59 "../plugins/word-completion/engine.vala"
	g_return_if_fail (self != NULL);
#line 59 "../plugins/word-completion/engine.vala"
	g_return_if_fail (view != NULL);
#line 295 "engine.c"
	{
		ScratchPluginsPrefixTree* _tmp0_;
#line 61 "../plugins/word-completion/engine.vala"
		_tmp0_ = self->priv->prefix_tree;
#line 61 "../plugins/word-completion/engine.vala"
		g_rec_mutex_lock (&self->priv->__lock_prefix_tree);
#line 302 "engine.c"
		{
			GeeHashMap* _tmp1_;
#line 62 "../plugins/word-completion/engine.vala"
			_tmp1_ = self->text_view_words;
#line 62 "../plugins/word-completion/engine.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, view)) {
#line 309 "engine.c"
				GeeHashMap* _tmp2_;
				gpointer _tmp3_;
#line 63 "../plugins/word-completion/engine.vala"
				_tmp2_ = self->text_view_words;
#line 63 "../plugins/word-completion/engine.vala"
				_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, view);
#line 63 "../plugins/word-completion/engine.vala"
				_g_object_unref0 (self->priv->prefix_tree);
#line 63 "../plugins/word-completion/engine.vala"
				self->priv->prefix_tree = (ScratchPluginsPrefixTree*) _tmp3_;
#line 320 "engine.c"
			} else {
				ScratchPluginsPrefixTree* _tmp4_;
#line 66 "../plugins/word-completion/engine.vala"
				_tmp4_ = scratch_plugins_prefix_tree_new ();
#line 66 "../plugins/word-completion/engine.vala"
				_g_object_unref0 (self->priv->prefix_tree);
#line 66 "../plugins/word-completion/engine.vala"
				self->priv->prefix_tree = _tmp4_;
#line 329 "engine.c"
			}
		}
		__finally0:
		{
			ScratchPluginsPrefixTree* _tmp5_;
#line 61 "../plugins/word-completion/engine.vala"
			_tmp5_ = self->priv->prefix_tree;
#line 61 "../plugins/word-completion/engine.vala"
			g_rec_mutex_unlock (&self->priv->__lock_prefix_tree);
#line 339 "engine.c"
		}
#line 61 "../plugins/word-completion/engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 61 "../plugins/word-completion/engine.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 61 "../plugins/word-completion/engine.vala"
			g_clear_error (&_inner_error0_);
#line 61 "../plugins/word-completion/engine.vala"
			return;
#line 349 "engine.c"
		}
	}
#line 70 "../plugins/word-completion/engine.vala"
	_tmp6_ = gtk_text_view_get_buffer (view);
#line 70 "../plugins/word-completion/engine.vala"
	_tmp7_ = _tmp6_;
#line 70 "../plugins/word-completion/engine.vala"
	g_object_get (_tmp7_, "text", &_tmp8_, NULL);
#line 70 "../plugins/word-completion/engine.vala"
	_tmp9_ = _tmp8_;
#line 70 "../plugins/word-completion/engine.vala"
	_tmp10_ = _tmp9_;
#line 70 "../plugins/word-completion/engine.vala"
	_tmp11_ = strlen (_tmp10_);
#line 70 "../plugins/word-completion/engine.vala"
	_tmp12_ = _tmp11_;
#line 70 "../plugins/word-completion/engine.vala"
	_tmp13_ = _tmp12_ > 0;
#line 70 "../plugins/word-completion/engine.vala"
	_g_free0 (_tmp10_);
#line 70 "../plugins/word-completion/engine.vala"
	if (_tmp13_) {
#line 372 "engine.c"
		GtkTextBuffer* _tmp14_;
		GtkTextBuffer* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		GeeHashMap* _tmp19_;
		ScratchPluginsPrefixTree* _tmp20_;
#line 71 "../plugins/word-completion/engine.vala"
		_tmp14_ = gtk_text_view_get_buffer (view);
#line 71 "../plugins/word-completion/engine.vala"
		_tmp15_ = _tmp14_;
#line 71 "../plugins/word-completion/engine.vala"
		g_object_get (_tmp15_, "text", &_tmp16_, NULL);
#line 71 "../plugins/word-completion/engine.vala"
		_tmp17_ = _tmp16_;
#line 71 "../plugins/word-completion/engine.vala"
		_tmp18_ = _tmp17_;
#line 71 "../plugins/word-completion/engine.vala"
		euclide_completion_parser_parse_string (self, _tmp18_);
#line 71 "../plugins/word-completion/engine.vala"
		_g_free0 (_tmp18_);
#line 72 "../plugins/word-completion/engine.vala"
		_tmp19_ = self->text_view_words;
#line 72 "../plugins/word-completion/engine.vala"
		_tmp20_ = self->priv->prefix_tree;
#line 72 "../plugins/word-completion/engine.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp19_, view, _tmp20_);
#line 400 "engine.c"
	}
}

void
euclide_completion_parser_add_word (EuclideCompletionParser* self,
                                    const gchar* word)
{
	gint _tmp0_;
	gint _tmp1_;
	GError* _inner_error0_ = NULL;
#line 76 "../plugins/word-completion/engine.vala"
	g_return_if_fail (self != NULL);
#line 76 "../plugins/word-completion/engine.vala"
	g_return_if_fail (word != NULL);
#line 77 "../plugins/word-completion/engine.vala"
	_tmp0_ = strlen (word);
#line 77 "../plugins/word-completion/engine.vala"
	_tmp1_ = _tmp0_;
#line 77 "../plugins/word-completion/engine.vala"
	if (_tmp1_ < EUCLIDE_COMPLETION_PARSER_MINIMUM_WORD_LENGTH) {
#line 78 "../plugins/word-completion/engine.vala"
		return;
#line 423 "engine.c"
	}
	{
		ScratchPluginsPrefixTree* _tmp2_;
#line 80 "../plugins/word-completion/engine.vala"
		_tmp2_ = self->priv->prefix_tree;
#line 80 "../plugins/word-completion/engine.vala"
		g_rec_mutex_lock (&self->priv->__lock_prefix_tree);
#line 431 "engine.c"
		{
			ScratchPluginsPrefixTree* _tmp3_;
#line 81 "../plugins/word-completion/engine.vala"
			_tmp3_ = self->priv->prefix_tree;
#line 81 "../plugins/word-completion/engine.vala"
			scratch_plugins_prefix_tree_insert (_tmp3_, word);
#line 438 "engine.c"
		}
		__finally0:
		{
			ScratchPluginsPrefixTree* _tmp4_;
#line 80 "../plugins/word-completion/engine.vala"
			_tmp4_ = self->priv->prefix_tree;
#line 80 "../plugins/word-completion/engine.vala"
			g_rec_mutex_unlock (&self->priv->__lock_prefix_tree);
#line 447 "engine.c"
		}
#line 80 "../plugins/word-completion/engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 80 "../plugins/word-completion/engine.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 80 "../plugins/word-completion/engine.vala"
			g_clear_error (&_inner_error0_);
#line 80 "../plugins/word-completion/engine.vala"
			return;
#line 457 "engine.c"
		}
	}
}

void
euclide_completion_parser_cancel_parsing (EuclideCompletionParser* self)
{
#line 85 "../plugins/word-completion/engine.vala"
	g_return_if_fail (self != NULL);
#line 86 "../plugins/word-completion/engine.vala"
	self->parsing_cancelled = TRUE;
#line 469 "engine.c"
}

static gboolean
euclide_completion_parser_parse_string (EuclideCompletionParser* self,
                                        const gchar* text)
{
	gchar** word_array = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint word_array_length1;
	gint _word_array_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gboolean result;
#line 89 "../plugins/word-completion/engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 89 "../plugins/word-completion/engine.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 90 "../plugins/word-completion/engine.vala"
	self->parsing_cancelled = FALSE;
#line 91 "../plugins/word-completion/engine.vala"
	_tmp1_ = _tmp0_ = g_strsplit_set (text, EUCLIDE_COMPLETION_PARSER_DELIMITERS, EUCLIDE_COMPLETION_PARSER_MAX_TOKENS);
#line 91 "../plugins/word-completion/engine.vala"
	word_array = _tmp1_;
#line 91 "../plugins/word-completion/engine.vala"
	word_array_length1 = _vala_array_length (_tmp0_);
#line 91 "../plugins/word-completion/engine.vala"
	_word_array_size_ = word_array_length1;
#line 92 "../plugins/word-completion/engine.vala"
	_tmp2_ = word_array;
#line 92 "../plugins/word-completion/engine.vala"
	_tmp2__length1 = word_array_length1;
#line 502 "engine.c"
	{
		gchar** current_word_collection = NULL;
		gint current_word_collection_length1 = 0;
		gint _current_word_collection_size_ = 0;
		gint current_word_it = 0;
#line 92 "../plugins/word-completion/engine.vala"
		current_word_collection = _tmp2_;
#line 92 "../plugins/word-completion/engine.vala"
		current_word_collection_length1 = _tmp2__length1;
#line 92 "../plugins/word-completion/engine.vala"
		for (current_word_it = 0; current_word_it < current_word_collection_length1; current_word_it = current_word_it + 1) {
#line 514 "engine.c"
			gchar* _tmp3_;
			gchar* current_word = NULL;
#line 92 "../plugins/word-completion/engine.vala"
			_tmp3_ = g_strdup (current_word_collection[current_word_it]);
#line 92 "../plugins/word-completion/engine.vala"
			current_word = _tmp3_;
#line 521 "engine.c"
			{
				const gchar* _tmp4_;
#line 93 "../plugins/word-completion/engine.vala"
				if (self->parsing_cancelled) {
#line 94 "../plugins/word-completion/engine.vala"
					g_debug ("engine.vala:94: Cancelling parse");
#line 95 "../plugins/word-completion/engine.vala"
					result = FALSE;
#line 95 "../plugins/word-completion/engine.vala"
					_g_free0 (current_word);
#line 95 "../plugins/word-completion/engine.vala"
					word_array = (_vala_array_free (word_array, word_array_length1, (GDestroyNotify) g_free), NULL);
#line 95 "../plugins/word-completion/engine.vala"
					return result;
#line 536 "engine.c"
				}
#line 97 "../plugins/word-completion/engine.vala"
				_tmp4_ = current_word;
#line 97 "../plugins/word-completion/engine.vala"
				euclide_completion_parser_add_word (self, _tmp4_);
#line 92 "../plugins/word-completion/engine.vala"
				_g_free0 (current_word);
#line 544 "engine.c"
			}
		}
	}
#line 99 "../plugins/word-completion/engine.vala"
	result = TRUE;
#line 99 "../plugins/word-completion/engine.vala"
	word_array = (_vala_array_free (word_array, word_array_length1, (GDestroyNotify) g_free), NULL);
#line 99 "../plugins/word-completion/engine.vala"
	return result;
#line 554 "engine.c"
}

static void
euclide_completion_parser_class_init (EuclideCompletionParserClass * klass,
                                      gpointer klass_data)
{
#line 21 "../plugins/word-completion/engine.vala"
	euclide_completion_parser_parent_class = g_type_class_peek_parent (klass);
#line 21 "../plugins/word-completion/engine.vala"
	g_type_class_adjust_private_offset (klass, &EuclideCompletionParser_private_offset);
#line 21 "../plugins/word-completion/engine.vala"
	G_OBJECT_CLASS (klass)->finalize = euclide_completion_parser_finalize;
#line 567 "engine.c"
}

static void
euclide_completion_parser_instance_init (EuclideCompletionParser * self,
                                         gpointer klass)
{
#line 21 "../plugins/word-completion/engine.vala"
	self->priv = euclide_completion_parser_get_instance_private (self);
#line 25 "../plugins/word-completion/engine.vala"
	g_rec_mutex_init (&self->priv->__lock_prefix_tree);
#line 38 "../plugins/word-completion/engine.vala"
	self->parsing_cancelled = FALSE;
#line 580 "engine.c"
}

static void
euclide_completion_parser_finalize (GObject * obj)
{
	EuclideCompletionParser * self;
#line 21 "../plugins/word-completion/engine.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EUCLIDE_COMPLETION_TYPE_PARSER, EuclideCompletionParser);
#line 25 "../plugins/word-completion/engine.vala"
	g_rec_mutex_clear (&self->priv->__lock_prefix_tree);
#line 25 "../plugins/word-completion/engine.vala"
	_g_object_unref0 (self->priv->prefix_tree);
#line 37 "../plugins/word-completion/engine.vala"
	_g_object_unref0 (self->text_view_words);
#line 21 "../plugins/word-completion/engine.vala"
	G_OBJECT_CLASS (euclide_completion_parser_parent_class)->finalize (obj);
#line 597 "engine.c"
}

GType
euclide_completion_parser_get_type (void)
{
	return euclide_completion_parser_type_id;
}

GType
euclide_completion_parser_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (EuclideCompletionParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) euclide_completion_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EuclideCompletionParser), 0, (GInstanceInitFunc) euclide_completion_parser_instance_init, NULL };
	euclide_completion_parser_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "EuclideCompletionParser", &g_define_type_info, 0);
	EuclideCompletionParser_private_offset = sizeof (EuclideCompletionParserPrivate);
	return euclide_completion_parser_type_id;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

